{--
  Here is a small XQuery file used from the C interface
--}

{-- You may write type declarations in the XQuery type system syntax --}

define element bib { element book* }

define element book { 
  element title  { xsd:untyped },
  element year   { xsd:untyped },
  element author { xsd:untyped }+
}


{-- One global variable contains some XML --}

define global $bib0 {
  <bib>
    <book>
      <title>Data on the Web</title>
      <year>1999</year>
      <author>Abiteboul</author>
      <author>Buneman</author>
      <author>Suciu</author>
    </book>
    <book>
      <title>XML Query</title>
      <year>2001</year>
      <author>Fernandez</author>
      <author>Suciu</author>
    </book>
  </bib>
}

{-- Here is a function declarations, performing a simple selection --}

define function selectbook($x as xsd:string) as element book*
{
  for $v in ($bib0/book)
  where $v/title = $x
  return $v
}

{-- Here is another dummy function --}

define function test() as type xs:AnyType
{
  <a> { 1 } </a>
}

{-- Finally here is a function call --}

selectbook("Data on the Web")

