(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                            XML Query Engine                         *)
(*                                                                     *)
(*  Copyright 2000, Lucent Technologies.                               *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: load.mli,v 1.16 2002/10/27 20:02:51 simeon Exp $ *)

(****************************************************)
(* Loading well-formed XML in the XQuery Data Model *)
(****************************************************)

(* Loading operations *)

(*
val load_xml_forest : Namespace.nsenv -> Xml_ast.xml_node_forest -> Datamodel._Value
    (* Load a forest of XML nodes into the data model *)
*)

val load_xml_document : Namespace.nsenv -> Datatypes.xs_anyURI -> Xml_ast.xml_document -> Datamodel._Value
    (* Load a well-formed XML document into the data model *)

val load_xml_document_from_sax : Namespace.nsenv -> Datatypes.xs_anyURI -> Sax.doc_stream -> Datamodel._Value
    (* Load a well-formed XML document into the data model from the SAX stream *)

val load_project_xml_document_from_sax : Namespace.nsenv -> Path_struct.path_sequence -> Datatypes.xs_anyURI -> Sax.doc_stream -> Datamodel._Value
    (* Load & project! a well-formed XML document into the data model *)

