(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                            XML Query Engine                         *)
(*                                                                     *)
(*  Copyright 2000, Lucent Technologies.                               *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: theta.mli,v 1.6 2002/07/09 02:50:55 simeon Exp $ *)

(******************************************************)
(* This module implements operations on type mappings *)
(******************************************************)

(***********************)
(* Subsumption mapping *)
(***********************)

(* Type for subsumption mappings theta *)

type theta

(* Operations on subsumption mappings *)

val empty : theta

val add : Sym.rgroup_symbol -> Sym.rgroup_symbol -> theta -> theta

val find    : Sym.rgroup_symbol -> theta -> Sym.rgroup_symbol
val find_if : Sym.rgroup_symbol -> theta -> Sym.rgroup_symbol

val reverse : Sym.rgroup_symbol -> theta -> Sym.rgroup_symbol list

val merge : theta -> theta -> theta

val content : theta -> (Sym.rgroup_symbol * Sym.rgroup_symbol) list

