(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                            XML Query Engine                         *)
(*                                                                     *)
(*  Copyright 2000, Lucent Technologies.                               *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: xaeenv.mli,v 1.6 2002/12/03 00:01:42 simeon Exp $ *)

open Datamodel
open Sym
open Xquery_ast

(* Eval environment *)

type eenv

val generate_eenv: cquery_module -> eenv

val addevar: (eenv * vname * _Value) -> eenv
val addeevar: (eenv * vname * _Extended_Value) -> eenv
val addefctn: (eenv * (rfname * int) * cfunction_body) -> eenv

val getevar: (eenv * vname) -> _Value
val geteevar: (eenv * vname) -> _Extended_Value
val getefctn: (eenv * (rfname * int)) -> cfunction_body

val addekey: eenv -> (string * string * _Value) -> eenv

val getekey: eenv -> (string * string) -> _Value

