(***********************************************************************)
(*                                                                     *)
(*                                 GALAX                               *)
(*                            XML Query Engine                         *)
(*                                                                     *)
(*  Copyright 2000, Lucent Technologies.                               *)
(*  Distributed only by permission.                                    *)
(*                                                                     *)
(***********************************************************************)

(* $Id: xaeval.mli,v 1.4 2002/11/21 18:39:42 simeon Exp $ *)

val eval_cexpr: Xatenv.tenv -> Xaeenv.eenv -> Namespace.nsenv -> Xquery_ast.cexpr -> Datamodel._Value
    (* Evaluate an expression *)

val eval_toplevel: Xatenv.tenv -> Xaeenv.eenv -> Namespace.nsenv -> Xquery_ast.cquery_module -> Xaeenv.eenv
    (* Evaluate global declarations *)

val eval_query: Xatenv.tenv -> Xaeenv.eenv -> Namespace.nsenv -> Xquery_ast.cquery_module -> (Datamodel._Value) list
    (* Evaluate the whole query *)

val eval_cupdate: Xatenv.tenv -> Xaeenv.eenv -> Namespace.nsenv -> Xquery_ast.cupdate -> unit
    (* Evaluate an update *)
    (* Returns nothing -- just a side effect *)

val eval_cstatement: Xatenv.tenv -> Xaeenv.eenv -> Namespace.nsenv -> Xquery_ast.cstatement -> Datamodel._Value
    (* Evaluate a top level statement *)

