{-- ---------------------------
       Type Confusion Use Case
     --------------------------- --}


define element personLoose {
     element name {
        element last { xsd:string },
        element first { xsd:string }
     }
  }

define element personStrict {
     element name {
        element last { xsd:string },
        element first { xsd:string }+
     }
  }

define element color { type xs:AnyContentModel } 
define attribute color { atomic* } 

define global $person0 { treat as document (document("docs/person.xml")) }
define global $person1 { treat as document personLoose (glx:document-validate("docs/personLoose.xml","personLoose")) }
define global $person2 { treat as document personStrict (glx:document-validate("docs/personStrict.xml","personStrict")) }

define function swizzle-name($n as node) as xsd:string
  {
    typeswitch (name($n)) 
      case xsd:string $name return $name
      default return error()
  }

define function swizzle-color-attribute($n as attribute) as element
  {
     element color { $n/text() }
  }

define function swizzle-color-element($n as element) as attribute
  {
     attribute color { $n/text() }
  }

define function swizzle-element($n as element) as element
  { element { swizzle-name($n) }
     { swizzle-attribute

      typeswitch ($n) 
      case element color $n return
        attribute color { $n/text() }
      case attribute color $n return 
        element color { $n/text() } 
      case node $n return
        element { swizzle-name($n) } { for $x in
      (swizzle-elements($n/*), swizzle-attributes($n/@*) return swizzle($x) }
      default return
        element test { () } }

define global $blocks { treat as document (document("docs/confusion.xml")) }

