{-- Q1: List unique namespaces. --}
{-- Q1: List all unique namespaces used in the sample data. --}
<Q1>
   {
     for $n in distinct-values(
                   for $i in ($auction//* | $auction//@*)
                   return namespace-uri($i)
                )
     return  <ns>{$n}</ns>
   }
</Q1>

;
{-- Q2: Select titles in music namespace --}
{-- Q2: Select the title of each record that is for sale. --}
<Q2>
   {
     $auction//music:title
   }
</Q2>

;
{-- Q3: Select all attributes in dt namespace --}
{-- Q3: Select all attributes using datatypes from "XML Schema: Part 2" datatypes. --}
<Q3>
   {
     $auction//*[@dt:*]
   }
</Q3>

;
{-- Q4: List target URI's of xlinks --}
{-- Q4: List the target URI's of all XLinks in the document. --}
<Q4>
   {
     for $hr in $auction//@xlink:href
     return <ns>{ $hr }</ns>
   }
</Q4>

;
{-- Q5: Select on xml:lang attribute --}
{-- Q5: Select all records that have a remark in German. --}
<Q5>
   {
      $auction//music:record[music:remark/@xml:lang = "de"]
   }
</Q5>

;
{-- Q6: Select on existence of attribute --}
{-- Q6: Select the closing time elements of all AnyZone auctions currently monitored. --}
<Q6>
   {
     $auction//ma:Auction[@anyzone:ID]/ma:Schedule/ma:Close
   }
</Q6>

;
