{-- ------------------------------------------
       Use Case "R" : Access to Relational Data
     ------------------------------------------ --}

define element users { element user_tuple* }
define element user_tuple {
  element userid,
  element name,
  element rating?
}
define element userid { xsd:string }
define element name { xsd:string }
define element rating { xsd:string }

define element items { element item_tuple* }
define element item_tuple {
  element itemno,
  element description,
  element offered_by,
  element start_date?,
  element end_date?,
  element reserve_price?
}
define element itemno { xsd:int }
define element description { xsd:string }
define element offered_by { xsd:string }
define element start_date { xsd:string }
define element end_date { xsd:string }
define element reserve_price { xsd:int }

define element bids { element bid_tuple* }
define element bid_tuple {
  element userid,
  element itemno,
  element bid,
  element bid_date
}
define element userid { xsd:string }
define element itemno { xsd:int }
define element bid { xsd:int }
define element bid_date { xsd:string }

define element bid_count { element itemno, element nbids { xsd:int } }

define global $users { treat as document users  (glx:document-validate("docs/users.xml", "users")) }
define global $items { treat as document items  (glx:document-validate("docs/items.xml", "items")) }
define global $bids  { treat as document bids   (glx:document-validate("docs/bids.xml",  "bids" )) }

define function bid_summary() as element*
{
     for $i in distinct-values($bids//itemno)
     let $b := $bids//bid_tuple[itemno = $i]
     return
         <bid_count>
             { $i }
             <nbids>{ count($b) }</nbids>
         </bid_count>
}


