{-- ----------------------------------------
       Use Case "Seq" : Operations on trees
     ---------------------------------------- --}

define element report { element section* }

define element section { 
  element section.title, 
  element section.content 
}

define element section.title { xsd:string } 
define element section.content  { 
 ( text | 
   element anesthesia | 
   element prep | 
   element incision | 
   element action | 
   element observation )*
}
define element anesthesia { text }
define element prep { (text | element action)* }
define element incision { ( text | element geography | element instrument)* }
define element action { ( text | element instrument )* }
define element observation { text }

define element geography { text }
define element instrument { text }

define global $report1 { treat as document report (glx:document-validate("docs/report1.xml", "report")) } 

define function precedes($a as node, $b as node) as xsd:boolean
{
     $a << $b
       and
     empty($a//node() intersect $b)
}


define function follows($a as node, $b as node) as xsd:boolean
{
     $a >> $b
       and
     empty($b//node() intersect $a)
}


