{-- -----------------------------------------
       Use Case "SGML" : Operations on trees
     ----------------------------------------- --}

define element report { 
  element title, 
  element chapter+ 
}
define element title { 
  (text | element emph)* 
}
define element chapter { 
  attribute shorttitle { xsd:string }?,
  element title, 
  element intro?, 
  element section* 
}
define element intro { 
  (element para | element graphic)+ 
}
define element section { 
  attribute shorttitle { xsd:string }?,
  attribute sectid { xsd:string }?, {-- xsd:ID --}
  element title, 
  element intro?, 
  element topic* 
}
define element topic { 
  attribute shorttitle { xsd:string }?,
  attribute topicid { xsd:string }?, {-- xsd:ID --}
  element title, 
  (element para | element graphic)+
}
define element para { 
  attribute security { xsd:string }?, {-- (u | c | s | ts) "u" --}
  (text | element emph | element xref)*
}
define element emph { 
  (text | element emph)*
}
define element graphic { 
  attribute graphname { xsd:string } {-- ENTITY #REQUIRED --}
}
define element xref {
  attribute xrefid { xsd:string }? {-- IDREF #IMPLIED --}
}

define global $report { treat as document report (glx:document-validate("docs/sgml.xml","report")) }


