{-- -----------------------------------------
       Use Case "STRING" : String search
     ----------------------------------------- --}

define element company {
  element name, 
  element ticker_symbol?, 
  element description?,
  element business_code,
  element partners?, 
  element competitors?
}

define element name { xs:string }
define element ticker_symbol { xs:string }
define element description { xs:string }
define element business_code { xs:string }
define element partners { element partner+ }
define element partner { xs:string}
define element competitors { element competitor+ }
define element competitor { xs:string }

define element news {element news_item* }
define element news_item {
  element title, 
  element content, 
  element date, 
  element author?, 
  element news_agent
}
define element title { xs:string }
define element content { (element par | element figure) + }
define element date { xs:string }
define element author { xs:string }
define element news_agent { xs:string }
define element par { (text | element quote | element footnote) * }
define element quote { xs:string }
define element footnote { xs:string }
define element figure {element title, element image }
define element image { 
  attribute source { xs:string }
}
 
define global $input { treat as document news (glx:document-validate("docs/string.xml","news")) }


define global $company-data { treat as document news (glx:document-validate("docs/company-data.xml","company")) }

define function partners($company as xs:string) as element*
{
    let $c := $company-data//company[name = $company]
    return $c//partner
}

