{-- ---------------------------------------
       Use Case "Tree" : Operations on trees
     --------------------------------------- --}

define element book { 
  element title, 
  element author+, 
  element section+ 
}
define element title { xsd:string }
define element author { xsd:string } 

define element section { 
  attribute ID { xsd:string }?,
  attribute difficulty { xsd:string }?,
  element title, 
  (element p | element figure | element section)* 
}

define element p { xsd:string }

define element figure { 
  attribute height { xsd:string },
  attribute width  { xsd:string },
  element title, 
  element image 
} 

define element image { 
  attribute source { xsd:string }
}

define element section_summary { 
  attribute ID { xsd:string }?,
  attribute difficulty { xsd:string }?,
  element title, 
  element figcount { xsd:int }, 
  element section_summary*
}

define global $book1 { treat as document book (glx:document-validate("docs/book1.xml", "book")) }

define function toc($e as element) as element*
{
   let $n := local-name( $e )
   return
     if ($n = "section")
     then
         <section>
            { $e/@* }
            { for $s in $e/* return toc($s) }
         </section>
     else if ($n = "title")
     then $e
     else ()
}

define function section_summary($s as element section) as element
{
     <section>
         { $s/@* }
         { $s/title }
         <figcount>{ count($s/figure) }</figcount>
         {
             for $ss in $s/section
             return section_summary($ss)
         }
     </section>
}


