{-- ---------------------------------------
       Use Case "XMark" : XML Benchmark

       Thanks to our XMark friends!
       http://monetdb.cwi.nl/xml/
     --------------------------------------- --}

define element site {
  element regions,
  element categories,
  element catgraph,
  element people,
  element open_auctions,
  element closed_auctions
}
  
define element categories { element category+ }
define element category {
  attribute id,
  element name,
  element description
}

define attribute id { xsd:string }

define element name { xsd:string }

define element description { element :text | element parlist }
define element text {
  (xsd:string | element bold | element keyword | element emph)*
}

define element bold { (xsd:string | element bold | element keyword | element emph)* }
define element keyword { (xsd:string | element bold | element keyword | element emph)* }
define element emph { (xsd:string | element bold | element keyword | element emph)* }
define element parlist { element listitem* }
define element listitem { (element :text | element parlist)* }
  
define element catgraph { element edge* }
define element edge { attribute from, attribute to }
define attribute from { xsd:string }
define attribute to { xsd:string }
  
define element regions {
  element africa,
  element asia,
  element australia,
  element europe,
  element namerica,
  element samerica
}
define element africa          { element item* }
define element asia            { element item* }
define element australia       { element item* }
define element namerica        { element item* }
define element samerica        { element item* }
define element europe          { element item* }

define element item {
  attribute id,
  attribute featured?,
  element location,
  element quantity,
  element name,
  element payment,
  element description,
  element shipping,
  element incategory+,
  element mailbox
}
define attribute item { xsd:string }
define attribute featured { xsd:string }

define element location        { xsd:string }
define element quantity        { xsd:string }
define element payment         { xsd:string }
define element shipping        { xsd:string }
define element reserve         { xsd:string }
define element incategory { attribute category }
define attribute category { xsd:string }
define element mailbox         { element mail* }
define element mail            { element from, element to, element date, element :text }
define element from            { xsd:string }
define element to              { xsd:string }
define element date            { xsd:string }
define element itemref { attribute item }
define attribute item { xsd:string }
define element personref { attribute person }
define attribute person { xsd:string }
  
define element people          { element person* }
define element person          { attribute id, element name, element emailaddress, element phone?, element address?, element homepage?, element creditcard?, element profile?, element watches? }

define element emailaddress    { xsd:string }
define element phone           { xsd:string }
define element address         { element street, element city, element country, element province?, element zipcode }
define element street          { xsd:string }
define element city            { xsd:string }
define element province        { xsd:string }
define element zipcode         { xsd:string }
define element country         { xsd:string }
define element homepage        { xsd:string }
define element creditcard      { xsd:string }
define element profile         { attribute income, element interest*, element education?, element gender?, element business, element age? }
define attribute income { xsd:string }
define element interest { attribute category }

define element education       { xsd:string }
define element income          { xsd:string }
define element gender          { xsd:string }
define element business        { xsd:string }
define element age             { xsd:string }
define element watches         { element watch* }
define element watch { attribute open_auction }
define attribute open_auction { xsd:string }
  
define element open_auctions   { element open_auction* }
define element open_auction    { attribute id, element initial, element reserve?, element bidder*, element current, element privacy?, element itemref, element seller, element annotation, element quantity, element :type, element interval }
define element privacy         { xsd:string }
define element initial         { xsd:string }
define element bidder          { element date, element time, element personref, element increase }
define element seller { attribute person }

define element current         { xsd:string }
define element increase        { xsd:string }
define element type            { xsd:string }
define element interval        { element start, element end }
define element start           { xsd:string }
define element end             { xsd:string }
define element time            { xsd:string }
define element status          { xsd:string }
define element amount          { xsd:string }
  
define element closed_auctions { element closed_auction* }
define element closed_auction  { element seller, element buyer, element itemref, element price, element date, element quantity, element :type, element annotation? }
define element buyer { attribute person }
define element price           { xsd:string }
define element annotation      { element author, element description?, element happiness }
  
define element author { attribute person }
define element happiness       { xsd:string }


define global $auction { treat as document site (document("docs/xmark.xml")) }

define function convert($v)
{
  2.20371 * $v {-- convert Dfl to Euro --}
}

