{-- Q0:  Input XML Schema and Type --}
{-- Q0:  What is the input purchase order and its type? --}

($po);

{-- Q1:  Infering navigation types. --}
{-- Q1:  What is the recipient of the purchase order? --}

$po/HisPo:purchaseOrder/HisPo:shipTo/HisPo:name;

{-- Q2:  Creation of a local XML Schema element --}
{-- Q2:  Create an order for each product, with its name and quantity. --}

<order>
  { for $v in $po/HisPo:purchaseOrder/HisPo:items/HisPo:item
    return
    <heritem>
      { ($v/HisPo:productName, $v/HisPo:quantity) }
    </heritem> }
</order>;

{-- Q3:  Creation of a global XML Schema element --}
{-- Q3:  Create a small order from a normal order. --}

<HisPo:smallorder>
  { for $v in $po/HisPo:purchaseOrder/HisPo:items/HisPo:item
    return
    <HisPo:smallitem>
      { ($v/HisPo:productName, $v/HisPo:quantity) }
    </HisPo:smallitem> }
</HisPo:smallorder>;

{-- Q5:  Converting between two XML Schemas --}
{-- Q5:  Convert his purchase order into her purchase order. --}
<HerPo:order>
  { for $v in $po/HisPo:purchaseOrder/HisPo:items/HisPo:item
    return
    <HerPo:item>
      { ($v/HisPo:productName, $v/HisPo:quantity) }
    </HerPo:item> }
</HerPo:order>;


{-- Q6:  REALLY converting between two XML Schemas --}
{-- Q6:  Convert his purchase order into her purchase order. --}

<HerPo:order>
  { for $v in $po/HisPo:purchaseOrder/HisPo:items/HisPo:item
    return
    <HerPo:item>
      <HerPo:productName>
         { data($v/HisPo:productName) }
      </HerPo:productName>
      <HerPo:quantity>
         { data($v/HisPo:quantity) }
      </HerPo:quantity>
    </HerPo:item> }
</HerPo:order>;

{-- Q4:  Error in global element creation --}
{-- Q4:  Example of error in creating a small order from a normal order. --}
<HisPo:smallorder>
  { for $v in $po/HisPo:purchaseOrder/HisPo:items/HisPo:item
    return
    <HisPo:smallitem>
      { ($v/HisPo:productName) }
    </HisPo:smallitem> }
</HisPo:smallorder>

